package wipi_book_lui;

import org.kwis.msp.lcdui.*;
import java.util.Date;


public class ScrollList implements Runnable{

    //int x
    int m_startPosX = 0  ;
    int m_startPosY = 0  ;
    int m_ContainerWidth    = 100 ;
    int m_ContainerHeight   = 100 ;

    //Ʈ ִ 
    int m_TOTALLISTCOUNT  =  6 ;

    //Ʈ  Ʈ
    public  ListItem[] m_listitems ;

    private int m_topMrg;
    private int m_leftMrg;

    /** ȭ鿡 ׷ ù°  ȣ **/
    protected int m_startXItem ;
    /** õ  ȣ**/
    public int m_selectXItem ;
    //ũ  ġ
    int m_SelectorPos = 0;
    //ũѹ ũ
    int m_selectorHeight = 1 ;
    //ũѹ Ϸ Ŭ ?
    int m_movingWeight = 0;
    //ѹ  ؾ ѹ ũ Ǵ
    int m_TickedCnt = 0;


    //Ʈ ŸƲ  帣 ϴ    
    Thread marquer ;

    public long m_drawedtime = 0;
    boolean m_ismarquesstop = true ;
    boolean m_iskeypressed = false ;
    String m_marquedStr = null ;
    private boolean m_isActive ;




    //scrollList  SCROLLBAR  ( )
    private int m_scrollbarwidth = 4;
    private int m_listHeight = 0 ;

    //INTERFACE ADAPTOR
    ScrollListAdaptor caller ;


    //ý  
    public int m_BGcolor = 0xA7CA94 ;
    //ְ Ȥ 
    private boolean m_isBGEnable = true ;


    /**
     * ũ ٸ Ѵ.
     * @param _caller    ũ ٸ θ
     * @param x         x ǥ
     * @param y         y ǥ
     * @param width     
     * @param height    
     * @param listitems ׷ 
     */
    public ScrollList(ScrollListAdaptor _caller,  int x , int y , int width , int height , ListItem[] listitems ){
        caller = _caller ;
        m_startPosX = x ;
        m_startPosY = y ;
        m_ContainerWidth  = width ;
        m_ContainerHeight = height ;
        m_TOTALLISTCOUNT = height ;
        m_listitems = listitems ;
        if(listitems.length > 0){
            //׸  Ǵ  ǥ   Ѵ.
            calcBasicValues();
            m_marquedStr = listitems[m_selectXItem].title +"  "  ;
        }
    }


    /**
     * Ʈ ׸.
     * @param g
     */
    public void drawList(Graphics g){

        int currentX = getLeftMargin();
        int currentY = getTopMargin();
        int strHeight = g.getFont().getHeight();


        g.setColor(0);
        for( int i = m_startXItem ; i <  m_startXItem + m_TOTALLISTCOUNT ; i++)
        {
            currentX = getLeftMargin();
            if( i >= m_listitems.length)
                break;

            /////////////////// õ  ǥ ////////////////////////////

            if( i == m_selectXItem ){
                if(m_isBGEnable){
                    g.setColor(m_BGcolor);
//                    g.setColor( 0x85B8FF);
                    // Ų
                    drawSelectBar(g, 0x85B8FF, m_startPosX, currentY, m_ContainerWidth , strHeight+3);
                }
            }
            g.setColor(0);
            Image img = null ;
            if(m_listitems[i].isActive) img = m_listitems[i].item_img1;
            else img  = m_listitems[i].item_img2;
            // title ߰ ׸ ׸.  Exception .
            try{
                if(img != null) g.drawImage(img, currentX, currentY ,g.LEFT|g.TOP );
                if(m_listitems[i].item_img1 != null) currentX = currentX +  m_listitems[i].item_img1.getWidth()+2 ;
            }catch(Exception e){
            }
            //۾ 
            if( i == m_selectXItem ){
                g.drawString(m_marquedStr, currentX , currentY, g.LEFT | g.TOP );
            }else{
                g.drawString(m_listitems[i].title, currentX , currentY, g.LEFT | g.TOP );
            }

            // ̵
            currentY += (m_listHeight) ;
        }
        if(m_listitems.length > m_TOTALLISTCOUNT)
            paintScrollBar(g);
    }

    /**
     *   ٲ۴.
     * @param R
     * @param G
     * @param b
     */
    public void setBGcolor(int R, int G , int B){
        m_BGcolor = R << 16 |
                    G <<  8 |
                    B ;
    }


    /**
     * scroll Item ٲ.
     * @param items
     */
    public void ItemChanged(ListItem[] items){
        m_listitems =   items ;
        m_selectXItem = 0;
        m_startXItem = 0;
        calcBasicValues();
    }

    /**
     *  õ index
     * @return
     */
    public int currentIndex(){
        return m_selectXItem;
    }


    /**
     * ũѹٸ ̰ Ѵ.
     * @param g
     */
    private void paintScrollBar(Graphics g){

        m_selectorHeight = getSelectorHeight();
        //
        g.setColor(255,255,255);
        g.fillRect( m_startPosX +  m_ContainerWidth - m_scrollbarwidth -2 , m_startPosY , m_scrollbarwidth  + 2  , m_TOTALLISTCOUNT * m_listHeight  );
        //üũ ٸ ׸
        g.setColor(0);
        g.drawRect(m_startPosX + m_ContainerWidth - m_scrollbarwidth-1 , m_startPosY , m_scrollbarwidth-1 , m_TOTALLISTCOUNT * m_listHeight);
        g.setColor(0x540000);
        //Selector ׸
        g.fillRect(m_startPosX + m_ContainerWidth - m_scrollbarwidth-1 , m_startPosY + m_listHeight * m_SelectorPos  , m_scrollbarwidth-1 , m_listHeight *  m_selectorHeight) ;
        g.setColor(0);
    }

    /**
     * ũѹ selector ̸ Ѵ.
     * @return
     */
    private int getSelectorHeight(){
        int height = m_TOTALLISTCOUNT *  m_TOTALLISTCOUNT / m_listitems.length ;
        return height  ;
    }

    /**
     *  Activeγ  ´.
     * @return
     */
    public int getActiveCnt(){
        int selectedcnt = 0;
        for(int i= 0 ; i <  m_listitems.length ; i++)
            if(!m_listitems[i].isActive)  selectedcnt++;
        return selectedcnt ;
    }

   /**
    * Ű up 
    */
    public   void moveUp()
    {
        if(m_isBGEnable){
            m_selectXItem --;
            if( m_selectXItem < 0){
                m_selectXItem = 0;
            }

            //   . ġ  
            //ũѵ ű
            //start Point  ű
            if(m_startXItem == m_selectXItem + 1){
                m_startXItem -- ;
                scrollUp();
                if(m_startXItem <= 0){
                    m_startXItem = 0;
                    scrollTop();
                }
            }
        }
        else {
            m_startXItem -- ;
            scrollUp();
            if(m_startXItem <= 0){
                m_startXItem = 0;
                scrollTop();
            }
        }
        //ũ   ۾
        m_marquedStr = m_listitems[m_selectXItem].title+"  "  ;
    }

  /**
   * Ű down 
   */
    public void moveDown()
    {
        m_drawedtime = new Date().getTime();

        if(m_isBGEnable){
            m_selectXItem++;
            if( m_selectXItem >= m_listitems.length)  // ü Ʈ  ʰ ϵ Ѵ.
            {
                m_selectXItem--;
            }

            //õȰ   Ѿ   ĭ .
            //ũѵ 
            if( m_selectXItem > m_startXItem + m_TOTALLISTCOUNT -1 ){
                m_startXItem ++ ;
                scrollDown();
                // ̻ Ѿ ʰ
                if(m_startXItem >= m_listitems.length-m_TOTALLISTCOUNT){
                    m_startXItem = m_listitems.length-m_TOTALLISTCOUNT ;
                    scrollBot();
                }
            }
        }
        else{
            m_startXItem ++ ;
            scrollDown();
            if(m_startXItem >= m_listitems.length - m_TOTALLISTCOUNT ){
                m_startXItem = m_listitems.length - m_TOTALLISTCOUNT ;
                scrollBot();
            }
      }
        //ũ   ۾
        m_marquedStr = m_listitems[m_selectXItem].title+"  "  ;
    }

    /**
     *  ű.
     */
    public void moveLeft(){
        m_drawedtime = new Date().getTime();
    }


    /**
     *  ű.
     */
    public void moveRight(){
        m_drawedtime = new Date().getTime();
    }


    /**
     *  Ǿ
     * @return
     */
    public ListItem SelectPressed(){
        return m_listitems[m_selectXItem];
    }

    /**
     * marque Ѵ.
     */
    public void startMarque(){
        marquer = new Thread(this);
        m_ismarquesstop = true ;
        marquer.start();
    }

    public void stopMarque(){
        m_ismarquesstop = false ;
    }


    /**
     * scroll marque activeѴ.
     */
    public void setMarqueActive(boolean setflag){
        m_isActive = setflag ;
    }

    /**
     * ý  ̰ Ǵ  ʰ
     */
    public void setSelectionMode(boolean mode){
        m_isBGEnable = mode;
        m_movingWeight = 1 ;
    }


    /**
     *   帣°   ְ
     * @return
     */
    public boolean getMarqueActive(){
        return m_isActive;
    }


  /**
   * õ ׸ ùٸ ׸.
   * @param g
   * @param color
   * @param x
   * @param y
   * @param width
   * @param height
   */
    private void drawSelectBar(Graphics g, int color, int x,  int y, int width, int height)
    {
        int oldColor = g.getColor();
        g.setColor(color);
        g.fillRect(x, y, width, height);
        g.setColor(oldColor);
    }


    /**
     * ׸  ⺻  Ѵ.
     */
    void calcBasicValues(){
        m_topMrg = 0 ;
        m_leftMrg = 0;
        int strHeight = 12 ;
        m_listHeight = strHeight + 5 ;
        m_TOTALLISTCOUNT = m_ContainerHeight/ m_listHeight ;
        int noncoverlength = m_listitems.length - m_TOTALLISTCOUNT ;
        int availableMovcnt =  m_TOTALLISTCOUNT - m_selectorHeight ;
        if(availableMovcnt > 0) {
            m_movingWeight = noncoverlength/availableMovcnt ;
            m_TickedCnt = m_movingWeight-1;
        }
        else m_movingWeight = 0  ;
        if(!m_isBGEnable) m_movingWeight = 1 ;
        if(m_listitems.length > 0)
            m_marquedStr = m_listitems[m_selectXItem].title +"  "  ;

    }


    /**
    * Top   
    * @return
    */
    private int getTopMargin()
    {
        return m_startPosY;
    }

    private void setTopMargin(int margin)
    {
        m_startPosY = margin;
    }

    /**
    * ʿ   
    * @return
    */
    private int getLeftMargin()
    {
        return m_startPosX ;
    }

    private void setLeftMargin(int margin)
    {
        m_startPosX = margin;
    }

    /**
     * Ŭ ũ ٰ ̴  Ѵ.
     * @return
     */
    private int calcMovWeight(){
        int weight = 1;
        if(m_isBGEnable){
            int noncoverlength = m_listitems.length - m_TOTALLISTCOUNT ;
            int availableMovcnt =  m_TOTALLISTCOUNT - m_selectorHeight ;
            weight = noncoverlength/availableMovcnt ;
        }else{
            weight = 1;
        }
        return weight;
    }

    /**
     *  ĭ ̵ߴµ ũѹٵ ű ؼ ó
     */
    private void scrollUp(){
        m_movingWeight = calcMovWeight();
        m_TickedCnt--;
        if(m_TickedCnt < 0){
            m_TickedCnt = m_movingWeight;
            m_SelectorPos--;
        }
    }

    /**
     * Ʒ ĭ ̵ߴµ ũѹٵ ű غ
     */
    private void scrollDown(){
        m_movingWeight = calcMovWeight();
        m_TickedCnt++;
        if(m_TickedCnt >= m_movingWeight){
            m_TickedCnt = 0;
            m_SelectorPos++;
        }
    }

    /**
     * ũѹ top
     */
    private void scrollTop(){
        m_SelectorPos = 0;
        m_TickedCnt = m_movingWeight -1;
    }

    /**
     * ũѹ ǾƷ
     */
    private void scrollBot(){
        m_SelectorPos = m_TOTALLISTCOUNT - m_selectorHeight;
        m_TickedCnt =  0 ;
    }

    //Thread 
    public  void run(){

        try{Thread.sleep(2000);}catch(Exception e){}
        while(m_ismarquesstop){
            try{Thread.sleep(500);}catch(Exception e){}

            int strwidth = Font.getDefaultFont().stringWidth(m_listitems[m_selectXItem].title);
            //̰ 
            if( strwidth < m_ContainerWidth - 30) {
            }
            //̰  MARQUEѴ.
            else{
                if(!m_isActive){
                    // 700и  ȴ 

                    m_marquedStr = m_listitems[m_selectXItem].title+"  " ;
                    for(int i = 0; ;i++){
                        if((new Date().getTime() - m_drawedtime ) >  2000){
                            try{Thread.sleep(500);}catch(Exception e){}
                            StringBuffer sb  = new StringBuffer(m_marquedStr.substring(1));
                            sb.append(m_marquedStr.substring(0,1));
                            m_marquedStr = new String(sb);
                            caller.drawScrollList();
                        }else{
                            m_marquedStr = m_listitems[m_selectXItem].title;
                            caller.drawScrollList();
                            break;
                        }//end if
                    }//end for
                }// end if
            }//end while
        }
    }

    public void setTime(){
        m_drawedtime = new Date().getTime();
    }

    public void free(){
        if(m_listitems != null) m_listitems = null ;
        if(marquer != null){
            m_drawedtime = new Date().getTime() ;
            m_ismarquesstop = false ;
            marquer = null ;
        }
    }

    /**
     * 乮  ª  迭 ٲ۴.
     * @param text
     * @param g
     * @param width Ʈ  ƾ 
     */
    public static final ListItem[] getItemArray(String text ,  int width,  Image img){

        ListItem[] listitems = new ListItem[20];
        String tmpstr = null ;
        Font f = Font.getDefaultFont();
        char c[] = new char[text.length()];
        text.getChars(0,text.length() , c ,0);
        int length = c.length;
        int offset = 0;
        int count = 0;

        while(length > 0)
        {
            for( int i = 0; i < c.length - offset ; i++){
                if( width - 5  < f.charsWidth(c,offset, i)){
                  length = i;
                  break;
                }
            }
            tmpstr = text.substring(offset,offset+length);
            if(count ==  0 )  listitems[count] = new ListItem(img ,img,tmpstr,tmpstr,false);
            else  listitems[count] = new ListItem(null,null,tmpstr,null,false);
            count++ ;
            offset += length ;
            length = c.length - offset;
        }
        ListItem[] returnitem  =  new ListItem[count] ;
        System.arraycopy(listitems,0,returnitem,0,count) ;
        return returnitem ;
    }
}