package wipi_book_netserver;

import	java.net.*;
import	java.io.*;
import	java.util.*;
import	java.sql.*;
import	java.text.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class TictactoeHandleServer implements TTTListenerHandler{

    /**
     *  
     */
    boolean on_stop_request = false  ;

    // μ ڵ
    TictactoeServer main = null ;

    //ӹ ID
    int gameRoomID =  0 ;

    //Ŭ̾Ʈ ڵ鷯
    TTTClientListenThread listenerA = null ;
    TTTClientListenThread listenerB = null ;

    /**
     * .
     * @param main
     * @param clientA
     * @param clientB
     * @param gameroomID
     */
    public TictactoeHandleServer(TictactoeServer main , TTTClientListenThread  clientA ,  TTTClientListenThread clientB , int gameroomID) {
        this.main = main ;
        listenerA = clientA;
        listenerB = clientB ;

        listenerA.firststart = false ;
        listenerB.firststart = true ;
        listenerA.caller = this ;
        listenerB.caller = this ;
        gameRoomID = gameroomID ;
        notifyGameStarted();
    }

    /**
     *
     */
    private void notifyGameStarted(){
        String StartString = TTTProtocol.M_GAMESTART ;
        try{
            listenerA.sendMsg((TTTProtocol.M_GAMESTART+":TRUE").getBytes());
            listenerB.sendMsg((TTTProtocol.M_GAMESTART+":FALSE").getBytes());
        }catch(Exception e){}
    }


    /**
     * Ŭ̾Ʈ O,X  ߴ. ٸ ̸ӿ Ѵ.
     * @param pos
     * @param isB
     */
    public void clientSelect(String pos , boolean isB){
        String sndstr = TTTProtocol.M_SELECT+":"+pos ;
        System.out.println(" sndstr =" + sndstr);
        try{
            if(isB)
                listenerA.sendMsg(sndstr.getBytes());
            else
                listenerB.sendMsg(sndstr.getBytes());
        }catch(Exception e){ }
    }


    /**
     * Ŭ̾Ʈ ο   ˸.
     * @param isB
     */
    public void clientnewGame(boolean  isB ){
        String sndstr = TTTProtocol.M_NEWGAME+":-" ;
        try{
            if(isB)
                listenerA.sendMsg(sndstr.getBytes());
            else
                listenerB.sendMsg(sndstr.getBytes());
        }catch(Exception e){ }

    }


    /**
     * Ŭ̾Ʈ   ߴ.
     * @param isB
     */
    public void clientExit(boolean isB){

        //濡 ٷ Ѵٰ Ѵ.
        if(isB){
            try{
                listenerA.sendMsg((TTTProtocol.M_BUYDYLEFT_WAITING+":-").getBytes());
            }catch(Exception e){}
            main.registerMetoWaitingClient(listenerA );
        }else{
            try{
                listenerB.sendMsg((TTTProtocol.M_BUYDYLEFT_WAITING+":-").getBytes());
            }catch(Exception e){}
            main.registerMetoWaitingClient(listenerB );
        }
        main.removeGameroom(gameRoomID);
    }


    public void setClientAlive(boolean isAlive){
    }

}