package wipi_book_network ;


import org.kwis.msf.io.*;
import java.io.* ;
import java.util.*;


public class HttpSocketUtil  implements HttpSocket {

    /**
     * URL.find() ޼ҵ  HttpSocekt ڵ
     */
HttpSocket  httpsocket = null ;

    /**
     *  http header key: value ϱ  ڷᱸ
     */
    public Hashtable m_hashHeaders = new Hashtable();

    /**
     *  header  content  ڷᱸ
     * @param httpsocket
     */
    byte[] headerbytes = null ;
    byte[] contentbytes = null ;


    /**
     * .
     * @param httpsocket
     */
    public HttpSocketUtil(HttpSocket  httpsocket) {
this.httpsocket = httpsocket ;
    }

    /**
     * WEB server   Ͽ   ´.
     */
    public void request(String method){
        InputStream dis = null;
        OutputStream dos = null;
        try{
            dis = httpsocket.getInputStream();
            dos = httpsocket.getOutputStream();
            String getFile =  getURL_host(httpsocket.getURL());
            byte[] reqbytes  = ("GET "+getFile+" HTTP/1.1\r\n\r\n").getBytes() ;
            dos.write(reqbytes);
            dos.flush();
            getRequest(dis);
        }catch(Exception e){
            System.out.println("Exception "+ e.getMessage());
        }finally{
            try{dis.close();}catch(Exception e){}
            try{dos.close();}catch(Exception e){}
            try{httpsocket.close();}catch(Exception e){}

        }
    }

    /**
     * header   ִ HashTable .
     * @return
     */
    public Hashtable getHeaders(){
        return m_hashHeaders;
    }


    /**
     * ʵ Ű  Ѵ.
     * @return
     */
    public String[] getHeaderKeys(){
        String[] keys = new String[m_hashHeaders.size()];
        Enumeration enum =  m_hashHeaders.keys();
        for(int i = 0;enum.hasMoreElements();i++){
            keys[i] = (String)enum.nextElement();
        }
        return keys;
    }

    /**
     * key شϴ  Ѵ.
     * @param key
     * @return
     */
    public String getHeaderValue(String _key){
        String key = null ;
        String value = null ;
        Enumeration enumkey =  m_hashHeaders.keys();
        Enumeration enumvalue =  m_hashHeaders.elements();

        for(int i = 0 ; enumkey.hasMoreElements() ; i++){
            key     = (String)enumkey.nextElement();
            value   = (String)enumvalue.nextElement();
            if(key.equals(_key))
                return value ;
        }
        return null;
    }

    /**
     *  Ѵ.
     * @return
     */
    public String getBody(){
        return new String(contentbytes);
    }

    /**
     * Ʈ ̸ Ѵ.
     * @return
     */
    public int getContentLength(){
        return contentbytes.length;
    }

    /**
     *   ۵ Ʈ ش Ʈ иϿ о´.
     * @param dis
     * @return
     */
    private void  getRequest(InputStream dis){
        int mode = 0;
        boolean loopflag = true ;
        boolean isHeadPassed = false ;
        int type = 0 ;

        byte[]  header = null ;
        int cnt = 0 ;

        while(loopflag){
            try{
                int a = dis.read();
                if(cnt == 8) System.out.print("-"+a);
                else if(cnt == 15) {
                    cnt = 0 ;
                    System.out.println(" "+a);
                }else System.out.print(" "+a);
                cnt++;
                if(isHeadPassed){
                    contentbytes  = addData2Chain(contentbytes,(byte) a);
                }else{
                    switch(a){
                        case '\r' :
                            if(mode == 0)    mode = 1 ;
                            else if(mode == 2 ) {
                                System.out.println("");
                                parseHeader(header);
                                header = null ;
                                mode = 3 ;
                            }
                            break;
                        case '\n' :
                            if(mode == 1)   mode = 2 ;
                            else if(mode == 3 ) {
                                mode = 4 ;
                                isHeadPassed = true;
                            }
                            break;
                        case -1 :
                            loopflag = false;
                            break ;
                        default :
                            if(mode==2){
                                System.out.println("");
                                parseHeader(header);
                                header = null ;
                            }
                            mode = 0 ;
                    }
                    headerbytes = addData2Chain(headerbytes,(byte) a);
                    header = addData2Chain(header,(byte) a);
                }
            }catch(Exception e){
                System.out.println("Exception ");
            }
        }
    }

    /**
     * 带 m_hashHeaders  Ѵ.
     * @param str
     */
    private void parseHeader(byte[] str){
        byte[] tmp = null ;
        if(str.length > 2){
            tmp = new byte[str.length-1];
        }
        System.arraycopy(str,0,tmp,0,tmp.length );
        String header = new String(tmp);
        int  index  = header.indexOf(":");
        if(index != -1){
            String key = header.substring(0,index);
            String value = header.substring(index+2).trim();
            m_hashHeaders.put(key,value);
        }
    }


    /**
     * URL  ȣƮ   Ѵ.
     * @param _url
     * @return
     */
    private String getURL_host(String _url){
        String url = new String(_url) ;
        System.out.println(" url="+_url);
        int index = _url.indexOf("//");
        url = url.substring(index+3);
        index = _url.indexOf("/");
        url = url.substring(index );
        return url ;
    }


    /**
     * byte  append Ų.
     * @param  ids ߰Ǵ byte
     * @param  idnum ߰ ID num
     */
    public static byte[]  addData2Chain(byte[] origine, byte added){
        byte[] temparray = null ;
        if(origine == null){
            origine = new byte[1];
            origine[0] = added ;
        }
        else{
            int originelength = origine.length ;
            temparray = origine ;
            origine = new byte[originelength+1] ;
            int i = 0 ;
            for(i = 0 ; i < temparray.length ; i++){
                origine[i] = temparray[i] ;
            }
            origine[i] = added ;

        }
        return origine ;

     }



// Ʒ κ HttpSocket ״ Ѵ.
    public void close() throws IOException{
         httpsocket.close();
    }

    public   InputStream getInputStream() throws IOException {
        return httpsocket.getInputStream();
    }

    public   OutputStream getOutputStream() throws IOException {
        return httpsocket.getOutputStream();
    }

    public   String getURL() {
        return httpsocket.getURL();
    }

    public   String getProtocol() {
        return httpsocket.getProtocol();
    }

    public   String getHost() {
        return httpsocket.getHost();
    }

    public   String getFile() {
        return httpsocket.getFile();
    }

    public   String getRef() {
        return httpsocket.getRef();
    }

    public   String getQuery() {
        return httpsocket.getQuery();
    }

    public   int getPort() {
        return httpsocket.getPort() ;
    }

    public   String getRequestMethod() {
        return httpsocket.getRequestMethod();
    }

    public   void setRequestMethod(String p0) throws IOException {
        httpsocket.setRequestMethod(p0);
    }

    public   String getRequestProperty(String p0) {
        return httpsocket.getRequestProperty( p0);
    }

    public   void setRequestProperty(String p0, String p1) throws IOException {
        httpsocket.setRequestProperty(p0,p1);
    }

    public   int getResponseCode() throws IOException {
        return httpsocket.getResponseCode() ;
    }

    public   String getResponseMessage() throws IOException {
        return httpsocket.getResponseMessage();
    }

    public   long getLength() {
        return httpsocket.getLength() ;
    }

    public   String getType() {
        return httpsocket.getType();
    }

    public   String getEncoding() {
        return httpsocket.getEncoding();
    }

    public   long getExpiration() {
        return httpsocket.getExpiration() ;
    }

    public   long getDate() {
        return httpsocket.getDate();
    }

    public   long getLastModified() {
        return httpsocket.getLastModified();
    }

    public   String getHeaderField(String p0) {
        return httpsocket.getHeaderField(p0);
    }

    public   void setProxy(String p0, int p1) throws IOException {
        httpsocket.setProxy(p0, p1);
    }

    public   boolean isRelocatable() {
        return httpsocket.isRelocatable();
    }

    public   HttpSocket relocation() throws IOException {
        return httpsocket.relocation();
    }
}
