package wipi_book_netserver;


import java.net.*;
import java.util.*;
import java.io.*;
/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class TictactoeServer  implements TTTListenerHandler{

    // Ʈ
    private	int	port			=	0;

    boolean on_stop_request = false  ;
    // Ŭ̾Ʈ ID
    int clientcnt = 0;

    //ϴ Ŭ̾Ʈ õ  
    boolean m_bwaiting = false ;
    Socket m_watingsocket = null ;
    TTTClientListenThread m_waiterListener = null ;
    boolean m_waitingbuddyAlive = false ;


    //  
    private int m_gameroomID = 0;
    Hashtable gamerooms = new Hashtable();

    /**
     * 
     * @param port
     */
    public TictactoeServer(int port) {
        this.port	=	port;
    }

    /**
     * Ŭ̾Ʈ  ޾ ̱ Ѵ.
     */
    public void routine() {

        ServerSocket	server	=	null;
        Socket	sock	=	null;

        try {
            server	=	new	ServerSocket(port);
        } catch (Exception e) {
            on_stop_request = true;
            System.out.println("̹  Ʈ̰ų  ƮԴϴ.");
            System.exit(0);
        }


        while(!on_stop_request) {
            try {
                System.out.println("ٸ ֽϴ ");
                sock	=	server.accept();
                TTTClientListenThread  clientlistener = new TTTClientListenThread(this,sock ,sock.getInputStream(), clientcnt++);
                System.out.println("m_bwaiting="+m_bwaiting);

                //  ְ ׳  
                if(m_bwaiting && isWaitingBuddyAlive()){
                    System.out.println("    ִ  ¦¦");
                    //  Ŭ̾Ʈ Žų  
                    int gameroomid = getNextgameroomID();
                    TictactoeHandleServer gamehandler = new TictactoeHandleServer( this ,m_waiterListener , clientlistener, getNextgameroomID());
                    //  ϰ .
                    gamerooms.put(new Integer(gameroomid),gamehandler);
                    m_bwaiting = false ;
                }
                //  ų ׾,
                else {
                    m_waiterListener = clientlistener ;
                    m_waiterListener.sendMsg((TTTProtocol.M_BUYDYWAITING+":-").getBytes() );
                    System.out.println(TTTProtocol.M_BUYDYWAITING+":-  .");
                    m_bwaiting = true ;
                }
            } catch (Exception e) {}
        }
    }

    /**
     * ִ ˻. is.read()޼ҵ带  Ѵ.
     * @return
     */
    private boolean isWaitingBuddyAlive(){
        try{
            m_waiterListener.sendMsg((TTTProtocol.M_BUDDYFIND+":-").getBytes() );
        }catch(Exception e ){
            e.printStackTrace();
            return false ;
        }


         m_waitingbuddyAlive = false ;
         //30  ٸ.
         for(int i = 0 ; i <  60 ; i ++){
            try{Thread.sleep(500);}catch(Exception e){}
            if(m_waitingbuddyAlive)
                return true;
         }
         return false ;
    }


    /**
     * ̴ Ŭ̾Ʈ  óѴ.
     * @param listener
     */
    public void setSock2WaitingSock(TTTClientListenThread listener  ){
        m_waiterListener = listener ;
        m_waiterListener.caller = this ;
        m_bwaiting = true ;
    }



    /**
     *  ش.
     * @param id
     */
    protected void removeGameroom(int id){
        Integer GameRoomIDKEY = new Integer(id);
        gamerooms.remove(GameRoomIDKEY);
    }

    /**
     *  Ŭ̾Ʈ  Ѵ.
     */
    protected void  registerMetoWaitingClient(TTTClientListenThread listener){
        //   ϰ  Ѵ.
        if(m_bwaiting) {
            int gameroomid = getNextgameroomID();
            TictactoeHandleServer gamehandler = new TictactoeHandleServer(this, m_waiterListener , listener  , getNextgameroomID());
            gamerooms.put(new Integer(gameroomid),gamehandler);
            m_bwaiting = false ;
        }
        //    Ű.
        else {
            setSock2WaitingSock(listener );
            m_bwaiting = true ;
        }
    }

    /**
     *   Ŭ̾Ʈ ID ´.
     * @return
     */
    public int getNextgameroomID(){
        return m_gameroomID++ ;
    }


    /**
     *  Ŭ̾Ʈ O,X  ߴ ó  ʴ´.
     * @param pos
     * @param start
     */
    public void clientSelect(String pos , boolean first){
    }

    /**
     *   Ѵ. õȴ.
     * @param first
     */
    public void clientnewGame(boolean  first ){
    }

    /**
     * ̴ Ŭ̾Ʈ  ߴ.
     * @param start
     */
    public void clientExit(boolean first){
        System.out.println("̴   .....");
        m_watingsocket = null;
        m_bwaiting = false ;
    }


    /**
     *  buddy  ִ ˷ش.
     * @param isAlive
     */
    public void setClientAlive(boolean isAlive){
        m_waitingbuddyAlive = isAlive;
        System.out.println("setClientAlive("+isAlive+") ȣ");
    }



    public static void main(String[] args) {
        int	port		=	0;
        try {
            port		=	Integer.parseInt(args[0]);
        } catch (Exception e) {
            System.out.println("Usage: java TictactoeServer [PORT] ");
            return;
        }

        try {
            TictactoeServer	ts	=	new	TictactoeServer(port);
            ts.routine();
        } catch (Exception e) {
            System.out.println("ERROR : " + e.getMessage());
        }
    }
}
